import { Inter } from 'next/font/google';
import { VendingMachineProvider } from '../context';

import './styles/globals.scss';

const inter = Inter({ subsets: ['latin'] });

async function getData() {
  const res = await fetch(`${process.env.NEXT_PUBLIC_API_URL}/api/products`, {
    cache: 'no-store',
  });

  if (!res.ok) {
    throw new Error('Failed to fetch products');
  }

  return res.json();
}

export const metadata = {
  title: 'Vending Machine',
  description: 'Generated by create next app',
  openGraph: {
    images:
      'https://gitlab.com/dimo.nenkov/vending-machine/-/raw/develop/public/images/img--vending-machine.JPG',
  },
};

export default async function RootLayout({ children }) {
  const productList = await getData();

  return (
    <html lang="en">
      <body className={inter.className}>
        <VendingMachineProvider products={productList}>
          {children}
        </VendingMachineProvider>
      </body>
    </html>
  );
}
